/*
 *  Primitive Collections for Java.
 *  Copyright (C) 2003  Sren Bak
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
import bak.pcj.list.IntDeque;
import bak.pcj.list.IntArrayDeque;

/**
 *  This examplifies the operations of a deque.
 *
 *  @author     S&oslash;ren Bak
 *  @version    1.0     2003/14/1
 */
public class DequeExample {
    public static void main(String[] args) {
        IntDeque q = new IntArrayDeque();

        //  Adding elements

        q.addFirst(1);          //  q=[1]
        q.addFirst(2);          //  q=[2,1]
        q.addFirst(3);          //  q=[3,2,1]

        q.addLast(0);           //  q=[3,2,1,0]

        //  Retrieving elements

        int v;
        v = q.getFirst();       //  v=3, q=[3,2,1,0]
        v = q.getLast();        //  v=0, q=[3,2,1,0]
        
        //  Removing elements

        v = q.removeFirst();    //  v=3, q=[2,1,0]
        v = q.removeLast();     //  v=0, q=[2,1]
    }
}